%define         ver %(echo %version | tr -d .)
Name:           openarena
Version:        0.6.0
Release:        4%{?dist}
Summary:        Open source first person shooter
Group:          Amusements/Games
License:        GPL
URL:            http://openarena.ws/
Source0:        http://openarena.ws/rel/%{ver}/oa%{ver}.tar.gz
Source1:        http://cheapy.deathmask.net/logo.gif
Source3:        openarena.desktop
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
Requires:       %{name}-data = %{version}
BuildRequires:  ImageMagick
BuildRequires:  SDL-devel openal-devel curl-devel
BuildRequires:  desktop-file-utils
%description
OpenArena is an open-source content package for Quake III Arena licensed under
the GPL, effectively creating a free stand-alone game.

%package data
Group:          Amusements/Games
Summary:        Data files for %{name}
Requires:       %{name}
%description data
OpenArena is an open-source content package for Quake III Arena licensed under
the GPL, effectively creating a free stand-alone game.
This package contains data files essential to play OpenArena.

%prep
%setup -q -c
#1. let us create wrapper for openarena and for openarena_ded
#   we can use one wrapper to that task
cat > %{name} << EOF
#!/bin/bash
BASEOA_HOME_DIR=\$HOME/.openarena/baseoa
DATA_DIR=%{_datadir}/%{name}
[[ -d \$BASEOA_HOME_DIR ]] || mkdir -p \$BASEOA_HOME_DIR
for file in \$(find \$DATA_DIR -type f -printf "%f "); do
    [[ -a \$BASEOA_HOME_DIR/\$file ]] \
    || ln -s \$DATA_DIR/\$file \$BASEOA_HOME_DIR/\$file
done
if [[ "\$0" =~ "ded" ]]; then
    exec %{_libexecdir}/%{name}/ioq3ded.%{_arch} "\$@"
else
    exec %{_libexecdir}/%{name}/ioquake3.%{_arch} "\$@"
fi
EOF
chmod +x %{name}
ln -s %{name} %{name}_ded
#2. unpack the sources
cd source
tar xfj ioq3sources.tar.bz2
cd ..
IOQ3=$(ls -d source/ioq3-*)

#3. copy all documentation to one directory and get rid of unexpected
#   permissions to make a %files section easier ;-)
mkdir -p doc/ioq3
cp -p $IOQ3/{BUGS,ChangeLog,NOTTODO,README,TODO,id-readme.txt,md4-readme.txt} doc/ioq3 
cp -p CHANGES COPYING CREDITS README doc
chmod -x doc/{COPYING,CREDITS,CHANGES}

#4. fix end-of-line encodings
for file in doc/{COPYING,CREDITS,CHANGES,README}; do
    sed s/\\r// -i $file
done

#5. convert a .gif file to .png format
convert %{SOURCE1} %{name}.png

%build
FLAGS="-fno-strict-aliasing -Wimplicit -Wstrict-prototypes \
       -DUSE_OPENAL=1 -DUSE_CURL=1 -DUSE_CURL_DLOPEN=1 \
       -DUSE_SDL_VIDEO=1 -DUSE_SDL_SOUND=1 $(sdl-config --cflags) \
       -DUSE_LOCAL_HEADERS=1"
%ifarch ppc
FLAGS="$FLAGS -DNO_VM_COMPILED"
%endif
make distclean -C source/ioq3-*
make build_debug DEBUG_CFLAGS="%{optflags} $FLAGS" -C source/ioq3-*

%install
rm -rf $RPM_BUILD_ROOT
IOQ3=$(ls -d source/ioq3-*)/build/debug-linux-%{_arch}
# there's no option to install unstripped binary files so we have to do it manually
mkdir -p $RPM_BUILD_ROOT%{_libexecdir}/%{name}
mkdir -p $RPM_BUILD_ROOT%{_datadir}/%{name}
mkdir -p $RPM_BUILD_ROOT%{_bindir}
mkdir $RPM_BUILD_ROOT%{_datadir}/pixmaps

# there's a lot of files we don't need
# all of them have 644 permissions
# so find them and delete them

find $IOQ3 -perm 644 -type f | xargs rm -rf

# removing files leaves a few empty directories
# we can remove them as well

find $IOQ3 -type d -empty | xargs rm -rf

# smp binary is also unneeded

rm -rf $IOQ3/*smp*

# the things we have done above make it easier to install the application

cp -rp $IOQ3/* $RPM_BUILD_ROOT%{_libexecdir}/%{name}
cp -p baseoa/* $RPM_BUILD_ROOT%{_datadir}/%{name}
cp -p %{name} %{name}_ded $RPM_BUILD_ROOT%{_bindir}
cp -p %{name}.png $RPM_BUILD_ROOT%{_datadir}/pixmaps

desktop-file-install --vendor="fedora"                        \
        --dir=$RPM_BUILD_ROOT%{_datadir}/applications         \
        %{SOURCE3}

%clean
rm -rf $RPM_BUILD_ROOT


%files
%defattr(-,root,root,-)
%doc doc/*
%{_bindir}/%{name}*
%{_libexecdir}/%{name}
%{_datadir}/applications/fedora-*
%{_datadir}/pixmaps/%{name}.png

%files data
%defattr(-,root,root,-)
%doc doc/COPYING
%{_datadir}/%{name}

%changelog
* Fri Jan 12 2007 Michał Bentkowski <mr.ecik at gmail.com> - 0.6.0-4
- Get rid of -maltivec flag

* Wed Jan 10 2007 Michał Bentkowski <mr.ecik at gmail.com> - 0.6.0-3
- Do some ppc fixes

* Wed Jan 03 2007 Michał Bentkowski <mr.ecik at gmail.com> - 0.6.0-2
- Add COPYING to data subpackage
- Remove LINUXNOTES from %%doc

* Mon Jan 01 2007 Michał Bentkowski <mr.ecik at gmail.com> - 0.6.0-1
- Initial new year release
